<?php

namespace Tests\Services\OrderService\SyncOrderByWMSOrderHeaderTest;

use App\Logistic;
use App\Owner;
use App\Services\common\DataHandlerService;
use App\Services\LogisticService;
use App\Services\OracleDOCOrderHeaderService;
use App\Services\OrderService;
use App\Services\OwnerService;
use App\Services\ShopService;
use App\Services\WarehouseService;
use App\Shop;
use App\Warehouse;
use Carbon\Carbon;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use Tests\TestCase;

class SyncOrderByWMSOrderHeaderTest extends TestCase
{
    /**
     * @var OrderService $service
     * @var OracleDOCOrderHeaderService $orderHeaderService
     * @var DataHandlerService $dataHandlerService
     * @var OwnerService $ownerService
     * @var LogisticService $logisticService
     * @var ShopService $shopService
     * @var WarehouseService $warehouseService
     */
    public $service;
    public $orderHeaderService;
    public $dataHandlerService;
    public $ownerService;
    public $logisticService;
    public $shopService;
    public $warehouseService;
    public function setUp(): void
    {
        parent::setUp();
        $this->service=app(OrderService::class);
        $this->orderHeaderService=app(OracleDOCOrderHeaderService::class);
    }
    public function testCreateOrUpdateOrderByWMSOrderHeaders()
    {
        $carbon =Carbon::now()->subHours(10);
        $date = '2020-09-18 18:13:50';
        $orderHeaders = $this->orderHeaderService->getWMSOrderOnStartDate($carbon);
        $this->service->syncOrderByWMSOrderHeaders($orderHeaders);
        $collect =null;
        foreach ($orderHeaders as $orderHeader) {
            $code = $orderHeader->orderno;
            $order = $collect->where('code',$code)->first();
            $this->assertNotNull($order);

            $warehouse = Warehouse::query()->where('code',$orderHeader->warehouseid)->first();
            if($orderHeader->warehouseid ?? false)
                $this->assertEquals($warehouse->id ?? '',$order->warehouse_id ?? '');

            $owner = Owner::query()->where('code',$orderHeader->customerid)->first();
            if($orderHeader->customerid ?? false)
                $this->assertEquals($order->owner_id ?? '',$owner->id??'');

            $logistic = Logistic::query()->where('code',$orderHeader->userdefine1??'')->first();
            if($orderHeader->userdefine1 ?? false)
                $this->assertEquals($logistic->id ?? '',$logistic->id ?? '');

            $shop = Shop::query()->where('name',$orderHeader->issuepartyname)->where('owner_id',$owner->id)->first();
            if($orderHeader->issuepartyname ?? false)
                $this->assertEquals($shop->name,$orderHeader->issuepartyname);

            $this->assertEquals($order->consignee_name ,$orderHeader->c_contact);
            $this->assertEquals($order->consignee_phone ,empty($orderHeader->c_tel2)?$orderHeader->c_tel1:$orderHeader->c_tel2);
            $this->assertEquals($order->province ,$orderHeader->c_province);
            $this->assertEquals($order->city ,$orderHeader->c_city);
            $this->assertEquals($order->district ,$orderHeader->c_district);
            $this->assertEquals($order->client_code ,$orderHeader->soreference1);
            $this->assertEquals($order->wms_edittime ,(string)$orderHeader->edittime);
            $this->assertEquals($order->wms_status ,$orderHeader->oracleBASCode_codename_c);
            $this->assertEquals((string)$order->created_at ,(string)$orderHeader->addtime);
        }
    }
}
